%
% N : dimension de l'espace
N=length(cell_mu{1});
% nb_classe : nombre de classe
nb_classe=length(cell_mu);
%
vec_Papp=Papp;
%
if length(vec_Papp)>1
    vec_tau_opt=nan(size(vec_Papp));
    vec_tau_lin=nan(size(vec_Papp));
    vec_tau_quad=nan(size(vec_Papp));
    vec_delta_tau_opt=nan(size(vec_Papp));
    vec_delta_tau_lin=nan(size(vec_Papp));
    vec_delta_tau_quad=nan(size(vec_Papp));
    h_bar = waitbar(0,'Please wait...');
end
%
for ind=1:length(vec_Papp)
    if ind>1
        waitbar(ind/length(vec_Papp),h_bar)
    end
    %
    Papp=vec_Papp(ind);
    %
    %=======================================
    % generation de la base d'apprentissage
    %=======================================
    if choix_bimodale==1
        nb_classe=2;
    end
    %
    if choix_discri>1
        [Xapp,dapp]=genere_base_de_donnees(Papp,cell_mu,cell_Gamma);
        %
        if choix_bimodale==1
            dapp(dapp==3)=1;
            dapp(dapp==4)=2;
        end
        %
        %======================================
        % representation de la base de donnees
        %======================================
        %
        if (ind==length(vec_Papp))&&(N==2)
            plot_Bapp
            %
            title(['Base d''apprentissage pour P_{app} = ' num2str(Papp)])
        end
    end
    %
    %===============================
    % generation d'une base de generalisation
    %===============================
    %
    if ind==1
        [Xgen,dgen]=genere_base_de_donnees(Pgen,cell_mu,cell_Gamma);
    end
    %
    if choix_bimodale==1
        dgen(dgen==3)=1;
        dgen(dgen==4)=2;
    end
    %
    % estimation des moments d'ordre 1 et 2
    %
    if choix_discri>1
        [cell_mu_est,cell_Gamma_est,Gamma_lin_est]=estime_cell_mu_et_cell_Gamma(Xapp,dapp);
    end
    %
    % Performance des discriminateurs
    %
    d_est_opt=discriminateur_stat(Xgen,cell_mu,cell_Gamma);
    %
    if choix_discri>1
        d_est_lin=discriminateur_stat(Xgen,cell_mu_est,Gamma_lin_est);
    end
    %
    if choix_discri>2
        d_est_quad=discriminateur_stat(Xgen,cell_mu_est,cell_Gamma_est);
    end
    %
    if choix_bimodale==1
        d_est_opt(d_est_opt==3)=1;
        d_est_opt(d_est_opt==4)=2;
    end
    %
    % calcul des taux de generalisation
    tau_opt=mean(dgen==d_est_opt);
    if ~strcmp(barre_erreur,'not_yet')
        Delta_opt=calcul_Delta(tau_opt,Pgen,barre_erreur);
    end
    if choix_discri>1
        tau_lin=mean(dgen==d_est_lin);
        Delta_lin=calcul_Delta(tau_lin,Pgen,barre_erreur);
    end
    if choix_discri>2
        tau_quad=mean(dgen==d_est_quad);
        Delta_quad=calcul_Delta(tau_quad,Pgen,barre_erreur);
    end
    %
    % trace des resultats
    %
    if length(vec_Papp)==1
        %
        if strcmp(barre_erreur,'not_yet')
            disp(['tau_g (mu et Gamma connues) = ' num2str(tau_opt,6)])
            %
        else
            disp(['tau_g (mu et Gamma connues) = ' num2str(tau_opt,6) ' +- ' num2str(Delta_opt,3)])
            %
            if choix_discri>1
                disp(['tau_g (lineaire) = ' num2str(tau_lin,6) ' +- ' num2str(Delta_lin,3)])
            end
            if choix_discri>2
                disp(['tau_g (quadratique) = ' num2str(tau_quad,6) ' +- ' num2str(Delta_quad,3)])
            end
        end
        %
        if (choix_trace_surf_discri==1)&&(N==2)
            choix_plot_ddp=0;
            num_fig=1;
            plot_surf_discr(cell_mu,cell_Gamma,'\mu et \Gamma connus','k',num_fig,choix_plot_ddp)
            %
            if choix_discri>1
                cell_Gamma_lin_est=cell(size(cell_Gamma_est));
                for c=1:length(cell_Gamma_lin_est)
                    cell_Gamma_lin_est{c}=Gamma_lin_est;
                end
                plot_surf_discr(cell_mu_est,cell_Gamma_lin_est,'lineaire','r',num_fig,choix_plot_ddp)
            end
            %
            if choix_discri>2
                plot_surf_discr(cell_mu_est,cell_Gamma_est,'quadratique','g',num_fig,choix_plot_ddp)
            end
        end
    else
        %        
        vec_tau_opt(ind)=tau_opt;
        vec_delta_tau_opt(ind)=Delta_opt;
        if choix_discri>1
            vec_tau_lin(ind)=tau_lin;
            vec_delta_tau_lin(ind)=Delta_lin;
        end
        if choix_discri>2
            vec_tau_quad(ind)=tau_quad;
            vec_delta_tau_quad(ind)=Delta_quad;
        end
    end
end
%
if length(vec_Papp)>1
    close(h_bar)
    %
    figure
    h=semilogx(vec_Papp,vec_tau_opt,'k.');set(h,'markersize',14)
    hold on
    h=semilogx(vec_Papp,vec_tau_lin,'r.');set(h,'markersize',14)
    h=semilogx(vec_Papp,vec_tau_quad,'g.');set(h,'markersize',14)
    %
    h=errorbar(vec_Papp,vec_tau_opt,vec_delta_tau_opt);set(h,'color','k');set(h,'linestyle','none')
    h=errorbar(vec_Papp,vec_tau_lin,vec_delta_tau_lin);set(h,'color','r');set(h,'linestyle','none')
    h=errorbar(vec_Papp,vec_tau_quad,vec_delta_tau_quad);set(h,'color','g');set(h,'linestyle','none')
    %
    xlabel('P_{app}')
    ylabel('\tau_g avec barre d''erreur')
    L=legend('\mu et \Gamma connues','lineaire','quadratique');
    set(L,'Location','southeast')
    grid on
    set(gca,'fontsize',16);
    set(gca,'xlim',[vec_Papp(1) vec_Papp(end)])
    set(gca,'ylim',[0.5 1])
end