function [cell_mu_est,cell_Gamma_est,Gamma_lin_est]=estime_cell_mu_et_cell_Gamma(X,d)
%
% [cell_mu_est,cell_Gamma_est,Gamma_lin_est]=estime_cell_mu_et_cell_Gamma(X,d);
%

unique_d=unique(d);
nb_classe=length(unique_d);
%
% initialisation
cell_Gamma_est=cell(nb_classe,1); 
cell_mu_est=cell_Gamma_est;
%
for c=1:nb_classe
    val_d=unique_d(c);
    ind=find(d==val_d);
    XX=X(:,ind);
    %
    % moyenne empirique
    mu=mean(XX,2);
    cell_mu_est{c}=mu;
    %
    N=length(ind);
    Y=XX-mu*ones(1,N);
    %
    % calcul de la matrice de covariance empirique
    if N>1
        Gamma=(Y*Y')/(N-1);
    else
        Gamma=Y*Y';
    end
    %
    cell_Gamma_est{c}=Gamma;
    %
    if nargout==3
        if c==1
            Gamma_lin_est=Gamma;
        else
            Gamma_lin_est=Gamma_lin_est+Gamma;
            if c==nb_classe
                Gamma_lin_est=Gamma_lin_est/nb_classe;
            end
        end
    end
end
%
end
