function [cell_mu,cell_Gamma]=genere_Gamma_et_mu(N,nb_classe,choix_R,choix_centre,choix_meme_matrice_de_covariance)
%
% [cell_mu,cell_Gamma]=genere_Gamma_et_mu(N,nb_classe,choix_R,choix_centre,choix_meme_matrice_de_covariance);
%
% sorties
%========
% cell_Gamma est une cellule de qui contient les differentes matrice de covariance
%

cell_mu=cell(nb_classe,1);
cell_Gamma=cell(nb_classe,1);
%
for c=1:nb_classe
    if choix_centre==1
        cell_mu{c}=zeros(N,1);
    elseif choix_centre==-1
        if c==1
            cell_mu{c}=randn(N,1);
            %cell_mu{c}=randn(N,1)/(N/10);
        else
            cell_mu{c}=-cell_mu{1};
        end
    else
        cell_mu{c}=randn(N,1);
        %cell_mu{c}=randn(N,1)/(N/10);
    end
    %
    if c==1
        %Gamma=eye(N);
        Gamma=genere_covariance_matrix(N);
    elseif choix_meme_matrice_de_covariance~=1
        Gamma=genere_covariance_matrix(N);
    end
    %
    if choix_R==1
        Gamma=real(Gamma);
    end
    %
    cell_Gamma{c}=Gamma;
end
%
end

function Gamma=genere_covariance_matrix(ordre,lambda,U)
%
% Gamma=genere_covariance_matrix(ordre,lambda,U);
%
if nargin<=1
    lambda=1.5*rand(1,ordre);
end
%
if nargin<=2
    U=genere_unitary_matrix(ordre);
end
%
Gamma=U*diag(lambda)*U';
Gamma=(Gamma+Gamma')/2;
%
end
%

function U=genere_unitary_matrix(ordre)
%
% U=genere_unitary_matrix(ordre);
%

M=randn(ordre)+1i*randn(ordre);
U=gramschmidt(M);
end

function Ug=gramschmidt(U)
%
% Ug=gramschmidt(U);
%

Ug=zeros(size(U));
%
for m=1:length(Ug)
    ee=U(:,m);
    %
    for mm=1:m-1
        eee=(Ug(:,mm)'*ee)*Ug(:,mm);
        ee=ee-eee;
    end
    %
    Ug(:,m)=ee/sqrt(abs(ee'*ee));
end

end