function plot_base_de_donnee(X,d,dd)
%
% plot_base_de_donnee(X,d,d_est)
%
% entrees
%========
% X est une matrice de taille 3xP qui contient les differents vecteurs de
% la base
% d est un vecteur de taille P 

if nargin==0
    disp('il manque les variables d''entrees X et d')
    return
end
% variable d'initialisation
init=1;
%
%% variable qui contient les differentes couleurs
cell_couleur={'b','r','g','k','c','m','w','y'};
if nargin==3
    cell_forme={'x','x','x','x','x','^','s','d'};
else
    cell_forme={'x','+','o','p','.','^','s','d'};
end
%
set(gca,'fontsize',12)
for c=1:max(d)
    couleur=cell_couleur{c};
    forme=cell_forme{c};
    ind=find(d==c);
    if ~isempty(ind)
        if isreal(X)
            if size(X,1)==2
                plot(X(1,ind),X(2,ind),[couleur forme])
            else
                plot3(X(1,ind),X(2,ind),X(3,ind),[couleur forme])
            end
        else
            plot3(real(X(1,ind)),imag(X(1,ind)),abs(X(2,ind)),[couleur forme])
        end
        %
        if init==1
            hold on
            init=0;
            set(gca,'fontsize',14)
        end
    end
end
grid on
%
if nargin==3
    for c=1:max(dd)
        couleur=cell_couleur{c};
        forme='o';
        ind=find(dd==c);
        if ~isempty(ind)
            if isreal(X)
                if size(X,1)==2
                    plot(X(1,ind),X(2,ind),[couleur forme])
                else
                    plot3(X(1,ind),X(2,ind),X(3,ind),[couleur forme])
                end
            else
                plot3(real(X(1,ind)),imag(X(1,ind)),abs(X(2,ind)),[couleur forme])
            end
            %
            if init==1
                hold on
                init=0;
            end
        end
    end

end

