function plot_matrice_de_confusion(d_vrai,d_est)
%
% plot_matrice_de_confusion(d_vrai,d_est)
%
% entrees
%=========
% d_vrai : vecteur colonne indiquant la classe "vraie"
% d_est : vecteur colonne indiquant la classe "estimee"
%
nb_classe=max(d_vrai);
%
set(gca,'fontsize',14)
plot([1 nb_classe],[1 nb_classe],'.w')
hold on
%
set(gca,'xlim',[0.5 nb_classe+0.5])
set(gca,'ylim',[0.5 nb_classe+0.5])
%
for n=1:nb_classe
    plot([n+0.5 n+0.5],[0.5 nb_classe+0.5],'k--')
    plot([0.5 nb_classe+0.5],[n+0.5 n+0.5],'k--')
    for m=1:nb_classe
        x=sum((d_vrai==n).*(d_est==m));
        %
        h_text=text(n,m,num2str(x));
        set(h_text,'HorizontalAlignment','center')
        set(h_text,'VerticalAlignment','cap')
        %
        set(h_text,'fontsize',24)
        if n==m
            set(h_text,'fontWeight','bold')
        end
    end
end
%
set(gca,'xtick',1:nb_classe)
set(gca,'ytick',1:nb_classe)
axis ij
xlabel('classe vraie')
ylabel('classe estimee')
%
