function plot_surf_discr_laplace(cell_mu,nom_legend,couleur,num_fig,choix_plot_ddp,Pomegaj)
%
% plot_surf_discr_laplace(cell_mu,nom_legend,couleur,num_fig,Pomegaj)
%

if nargin<=1
    nom_legend='Surf. discriminante';
end
if nargin<=2
    couleur='k';
end
if nargin<=3
    num_fig=1;
end
if nargin<=4
    choix_plot_ddp=0;
end
nb_classe=length(cell_mu);
if nargin<=5
    Pomegaj=ones(1,nb_classe)/nb_classe;
end
%
xlim=get(gca,'xlim');
ylim=get(gca,'ylim');
%
length_vec=600;
vec_x=linspace(xlim(1),xlim(2),length_vec);
vec_y=linspace(ylim(1),ylim(2),length_vec);
%
[X,Y]=meshgrid(vec_x,vec_y);
Z=[X(:).';Y(:)'];
%
N1=abs(Z(1,:)-cell_mu{1}(1))+abs(Z(2,:)-cell_mu{1}(2));
N2=abs(Z(1,:)-cell_mu{2}(1))+abs(Z(2,:)-cell_mu{2}(2));
%
Px_sachant_omegaj=nan(2,length(N1));
Px_sachant_omegaj(1,:)=1/4*exp(-N1);
Px_sachant_omegaj(2,:)=1/4*exp(-N2);
%
ima=nan(length_vec,length_vec,nb_classe);
for c=1:nb_classe
    ima(:,:,c)=reshape(Px_sachant_omegaj(c,:),length_vec,length_vec)*Pomegaj(c);
end
%
[max_ima,arg_max]=max(ima,[],3);
%
nb_label=max(arg_max(:));
%
figure(num_fig)
if length(unique(arg_max(:)))>1
    hold on
    %plot(cell_mu{1}(1),cell_mu{1}(2),'xk','markersize',16,'linewidth',3)
    %plot(cell_mu{2}(1),cell_mu{2}(2),'xk','markersize',16,'linewidth',3)
    [~,h] = contour(vec_x,vec_y,arg_max,1:nb_classe,couleur);
    %
    set(h,'LineWidth',2)
    L=legend;
    Legend=L.String;
    Legend{length(get(gca,'Children'))}=nom_legend;
    legend(Legend)
end
%
if choix_plot_ddp==1
    figure(10+num_fig);clf
    if nb_classe==2
        subplot(2,2,3)
        contourf(vec_x,vec_y,max_ima,15);
        title('max_{1,2} des ddp')
        vec=caxis;
        subplot(2,2,1)
        contourf(vec_x,vec_y,ima(:,:,1),15)
        caxis(vec)
        title('ddp de la classe 1')
        subplot(2,2,2)
        contourf(vec_x,vec_y,ima(:,:,2),15);
        caxis(vec)
        title('ddp de la classe 2')
        subplot(2,2,4)
        imagesc(vec_x,vec_y,arg_max)
        title('arg max_{1,2} des ddp')
        for n=1:4
            subplot(2,2,n)
            xlabel('x_1')
            ylabel('x_2')
            set(gca,'fontsize',14)
            h_col=colorbar;
            axis xy
        end
    elseif nb_classe==3
        subplot(2,3,4)
        contourf(vec_x,vec_y,max_ima,15);
        title('max_{1,2} des ddp')
        vec=caxis;
        subplot(2,3,1)
        contourf(vec_x,vec_y,ima(:,:,1),15)
        caxis(vec)
        title('ddp de la classe 1')
        subplot(2,3,2)
        contourf(vec_x,vec_y,ima(:,:,2),15);
        caxis(vec)
        title('ddp de la classe 2')
        subplot(2,3,3)
        contourf(vec_x,vec_y,ima(:,:,3),15);
        caxis(vec)
        title('ddp de la classe 2')
        subplot(2,3,5)
        imagesc(vec_x,vec_y,arg_max)
        title('arg max_{1,2} des ddp')
        for n=1:5
            subplot(2,3,n)
            xlabel('x_1')
            ylabel('x_2')
            set(gca,'fontsize',14)
            h_col=colorbar;
            axis xy
        end
    elseif nb_classe==4
        subplot(3,2,5)
        contourf(vec_x,vec_y,max_ima,15);
        title('max_{1,2} des ddp')
        vec=caxis;
        subplot(3,2,1)
        contourf(vec_x,vec_y,ima(:,:,1),15)
        caxis(vec)
        title('ddp de la classe 1')
        subplot(3,2,2)
        contourf(vec_x,vec_y,ima(:,:,2),15);
        caxis(vec)
        title('ddp de la classe 2')
        subplot(3,2,3)
        contourf(vec_x,vec_y,ima(:,:,3),15);
        caxis(vec)
        title('ddp de la classe 3')
        subplot(3,2,4)
        contourf(vec_x,vec_y,ima(:,:,4),15);
        caxis(vec)
        title('ddp de la classe 4')
        subplot(3,2,6)
        imagesc(vec_x,vec_y,arg_max)
        title('arg max_{1,2} des ddp')
        for n=1:6
            subplot(3,2,n)
            xlabel('x_1')
            ylabel('x_2')
            set(gca,'fontsize',14)
            h_col=colorbar;
            axis xy
        end
    end
    set(h_col,'Ticks',1:nb_label)
end